//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 17-1 #1
//
// Outputs the number of times each pushbutton was pressed and released,
// displays each time a value changes.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>
#include <ios.h>

typedef struct
{
   int press1;
   int release1;
   int press2;
   int release2;
} results_t;

results_t results;

int1 mode1=0, mode2=0;

#int_ext1
void button1_isr(void) {
   if(mode1) {
      ext_int_edge(1,L_TO_H);
      results.release1++;
   }
   else {
      ext_int_edge(1,H_TO_L);
      results.press1++;
   }  
   mode1 = !mode1;
   delay_ms(50);
}

#int_ext2
void button2_isr(void) {
   if(mode2) {
      ext_int_edge(2,L_TO_H);
      results.release2++;
   }
   else {
      ext_int_edge(2, H_TO_L);
      results.press2++;
   }
   mode2 = !mode2;
   delay_ms(50);
}

void main(void) 
{
   results_t old;
   
   memset(&results, 0, sizeof(results));
   
   enable_interrupts(INT_EXT1_H2L);
   enable_interrupts(INT_EXT2_H2L);
   enable_interrupts(GLOBAL);
   
   while(TRUE) 
   {
      if (memcmp(&results, &old, sizeof(results)) != 0)
      {
         cout << results.press1 << " B1 Presses, " << results.release1 << " B1 Releases" << endl;
         cout << results.press2 << " B2 Presses, " << results.release2 << " B2 Releases" << endl;
         
         memcpy(&old, &results, sizeof(results));
      }
   }
   
   for(;;);
}
