//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 17-1 #2
//
// Outputs degrees on a circle with a radius of 5000. Every time the push
// button is pressed, increments the x and y coordinates and calculates the
// new angle.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>
#include <math.h>

float y;
int16 degree, calcSDegree, prevCalcSDegree, calcCDegree, prevCalcCDegree;
int1 update=FALSE;

#int_ext1
void button_isr(void) {
   delay_ms(50);
   
   if(degree == 359)
      degree = 0;
   else
      degree++;

   y = sin(degree*(3.14/180));
   
   update=TRUE;
}

void main(void) 
{
   enable_interrupts(INT_EXT1_L2H);
   enable_interrupts(GLOBAL);
   
   y=0;
   degree=calcSDegree=prevCalcSDegree=calcCDegree=prevCalcCDegree=0;
   update=FALSE;
   
   while(TRUE) 
   {
      if(update) 
      {
         disable_interrupts(GLOBAL);
         calcSDegree = asin(y)*(180/3.14);
         enable_interrupts(GLOBAL);
         
         if(calcSDegree != prevCalcSDegree) 
         {
            prevCalcSDegree = calcSDegree;
            printf("\r\nDegree = %lu", calcSDegree);
         }
         
         update=FALSE;
      }
   }
   
   for(;;);
}
