//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 17-1 #3
//
// Measures the frequency of pulses on Pin C0.
// WARNING: Do not generate a signal below ground.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>

int1 detected=FALSE;
int16 count=0;

#int_ext
void ext_isr(void) {
   if(detected) {
      ext_int_edge(0, H_TO_L);
      count++;
   }
   else
      ext_int_edge(0, L_TO_H);
      
   detected = !detected;
}

void main(void) {   
   enable_interrupts(INT_EXT_H2L);
   enable_interrupts(GLOBAL);
   
   for(;;) {
      delay_ms(1000);
      printf("\r\nDetected Frequency = %lu", count);
      count = 0;
   }
   
   
   for(;;);
}
